% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transport_options.R
\name{transport_options}
\alias{transport_options}
\title{Function returning supported optimal transportation methods.}
\usage{
transport_options()
}
\value{
Returns a vector of supported transport methods
}
\description{
Function returning supported optimal transportation methods.
}
\details{
The currently supported methods are
\itemize{
\item{exact, networkflow:}{ Utilize the networkflow algorithm to solve the exact optimal transport problem}
\item{shortsimplex:}{ Use the shortsimplex algorithm to solve the exact optimal transport problem}
\item{sinkhorn:}{ Use Sinkhorn's algorithm to solve the approximate optimal transport problem}
\item{greenkhorn:}{ Use the Greenkhorn algorithm to solve the approximate optimal transport problem}
\item{randkhorn:}{ (NOT CURRENTLY IMPLEMENTED) Use the randkhorn algorithm to solve the approximate optimal transport problem}
\item{grandkhorn:}{ (NOT CURRENTLY IMPLEMENTED) Use the grandkhorn algorithm to solve the approximate optimal transport problem}
\item{hilbert:}{ Use hilbert sorting to perform approximate optimal transport}
\item{rank:}{ use the average covariate ranks to perform approximate optimal transport}
\item{univariate:}{ Use appropriate optimal transport methods for univariate data}
\item{swapping:}{ Utilize the swapping algorithm to perform approximate optimal transport}
\item{sliced:}{ Use the sliced optimal transport distance}
}
}
